//	$Id: menu.h,v 1.2 2001/11/22 13:37:08 sugiura Exp $
/*
 *	menu.h
 *	j[\ɊւNX
 */

#ifndef	DENGAKUSERIES_CLASSES_MENU
#define	DENGAKUSERIES_CLASSES_MENU

#include "linklist.h"

class SessionInstance;

#define	MENUTYPE_SEPARATOR	0
#define	MENUTYPE_POPUP		1
#define	MENUTYPE_ITEM		2

#define MENURESULT_ERR_ID_MASK 0x8000

typedef struct {
	SessionInstance* m_pSessionInstance; // ZbVCX^X
	HMENU m_hMenu; // ŏɕ\郁j[̃nh
	POINT m_mnPosInfo; // j[\ʒu\\
	BOOL m_bShowAtCursor; // }EXJ[\̈ʒuɃj[\邩
	WORD m_wSelectedID;	//	Iꂽj[
	WORD m_wFirstShow; // ߂ WM_INITMENUPOPUP Ă΂ꂽƂɃtO낷
} SHOWMENUPROCARGS, *LPSHOWMENUPROCARGS;

class MenuItem {
public:
	MenuItem(WORD type,
			 const StringBuffer& text = nullStr,
			 const StringBuffer& subname = nullStr,
			 LPCSTR opt = NULL)
		:	m_text(text),
			m_subname(subname),
			m_type(type),
			m_state(readOpt(opt)),
			m_hmenu(NULL)
	{}

	static WORD readOpt(const StringBuffer&);

	const StringBuffer&	getText() const
	{
		return m_text;
	}

	const StringBuffer&	setText(const StringBuffer& str)
	{
		return m_text = str;
	}

	WORD getState() const { return m_state; }
	WORD setState(const StringBuffer& opt)
	{
		return m_state = readOpt(opt);
	}

	const StringBuffer&	getSubMenuName() const
	{
		return m_subname;
	}

	friend class Menu;
	friend class MenuList;

private:
	StringBuffer m_text; //	j[̃eLXg
	const StringBuffer m_subname;	//	Tuj[̖O()
	WORD m_type;	//	ڃ^Cv
	WORD m_state;	//	`FbNEL/̏
	HMENU m_hmenu;	//	Tuj[̃j[nh()

	MenuItem(const MenuItem&);
	MenuItem& operator=(const MenuItem&);
};

class Menu : public LinkList<MenuItem> {
public:
	Menu(const StringBuffer& name, BOOL bExMenu = FALSE)
		:	m_name(name),
			m_hMenu(NULL),
			m_bInitDone(FALSE),
			m_bExMenu(bExMenu)
	{}	//	nothing more to do.

	~Menu()
	{
		if (m_hMenu != NULL) ::DestroyMenu(m_hMenu);
	}

	BOOL isExMenu() const { return m_bExMenu; }
	const StringBuffer&	getName() const { return m_name; }

	friend class MenuList;

private:
	const StringBuffer m_name;	//	j[̖O
	HMENU m_hMenu;		//	j[nh
	BOOL m_bInitDone;	//	j[\zς݂ǂ
	BOOL m_bExMenu;		//	gj[ǂ
};

class MenuList : public NamedLinkList<Menu> {
public:
	MenuList()
		:	m_pLastMenu(NULL)
	{
		// nothing to do.
	}
	~MenuList()
	{
		this->deleteMenu();
	}

	int	addMenu(Menu*);

	Menu* getMenu(const StringBuffer& name = nullStr) const
	{
		if (name.length() <= 0) return m_pLastMenu;
		return m_HashName.getValue(name);
	}

	//	name [gƂ郁j[̃nhċAIɗ\񂷂
	HMENU precreateMenuRecursive(const StringBuffer& name);

	//	ۂ̃j[̍\z(w胁j[̂)
	HMENU createMenu(HMENU);

	//	j[nh̍폜
	void deleteMenu();

private:
	Menu* m_pLastMenu;	//	Poke ̑Ώۂ Menu NXւ̃|C^
};

#endif

