//	$Id: recfind.h,v 1.3 2002/02/15 17:46:08 sugiura Exp $
/*
 *	recfind.h
 *	enum** ֐̂߂̃pXNX
 */

#ifndef	DENGAKUSERIES_CLASSES_RECFINDFILE
#define	DENGAKUSERIES_CLASSES_RECFINDFILE

#include "strbuf.h"
#include "stack.h"
#include "pathname.h"
#include "enumpath.h"
#include "enumerator.h"

#define RECFIND_REVERSE		0x00001000	//	tɃ\[g
#define RECFIND_RECURSIVE	0x00002000	//	ċAIɌ
#define RECFIND_SHOWDIR		0x00004000	//	fBNg\

// predeclaration
class DirList;

// pXNXQ̊NX
class FindData : public Enumerator<StringBuffer> {
public:
	FindData(const DirList& dirlist, const PathName&);
	virtual ~FindData();

	// virtual methods of Enumerator
	BOOL isValid() const;
	BOOL findNext();
	StringBuffer getValue() const;

	DWORD getAttributes();
	DWORD getSize();
	const FILETIME*	getTime();

protected:
	const DirList& m_DirList;
	PathName m_pnPathBuf, m_pnForGetAttrib;
	StringBuffer m_sbBaseName;
	EnumSortedPath* m_pCurrentPath;	//	cannot be Auto_Ptr, see source
	BOOL m_bGotAttrib;

	FindData(const FindData&);
	FindData& operator=(const FindData&);

	BOOL setPath(const StringBuffer&, const StringBuffer&, DWORD);
};

//	t@Ĉ߂̃NX
class FindFile : public FindData {
public:
	FindFile(
		const DirList& dirlist,
		const PathName& path,
		const StringBuffer& filter,
		const StringBuffer& s_order,
		DWORD flags)
		: FindData(dirlist, path)
	{
		this->setPath(filter,s_order,ENUMPATH_FINDFILE|flags);
	}
};

//	fBNĝ߂̃NX
class FindDir : public FindData {
public:
	FindDir(
		const DirList& dirlist,
		const PathName& path,
		const StringBuffer& filter,
		const StringBuffer& s_order,
		DWORD flags)
		: FindData(dirlist, path)
	{
		this->setPath(filter,s_order,ENUMPATH_FINDDIR|flags);
	}
};

//	iċAjt@CEfBNĝ߂()NX
class RecFindData : public FindData {
public:
	RecFindData(
		const DirList& dirlist,
		const PathName&,
		const StringBuffer&,
		const StringBuffer&,
		const StringBuffer&,
		DWORD);
	~RecFindData();

	BOOL findNext() = 0; // to be overridden by extended classes
	StringBuffer getValue() const;

protected:
	const StringBuffer m_sDirFilter;	//	fBNg̃tB^
	const StringBuffer m_sFileFilter;	//	t@C̃tB^
	const StringBuffer m_sSortOrder;	//	\[gI[_[
	DWORD m_flags;	//	fBNgΏۂɊ܂߂邩ǂ
	int	m_nIniLength;		//	m_pnPathBuf ̒̏l
	BOOL m_bDirFirstTime;	//	hNXɂĎgقȂ̂Ń\[XQ
	Stack<EnumSortedPath> m_Stack;	//	EnumSortedPath* ̃X^bN

	//	ŏ̌̏
	BOOL initFileSearch();
	BOOL initDirSearch();
	virtual BOOL initSearch() = 0;

	//	X^bNɌf[^vbV
	void pushPath();
	EnumSortedPath*	popPath();
};

class RecFindForward : public RecFindData {
public:
	RecFindForward(
		const DirList& dirlist,
		const PathName&,
		const StringBuffer&,
		const StringBuffer&,
		const StringBuffer&,
		DWORD);

	BOOL findNext();

protected:
	BOOL initSearch();
};

class RecFindBackward : public RecFindData {
public:
	RecFindBackward(
		const DirList& dirlist,
		const PathName&,
		const StringBuffer&,
		const StringBuffer&,
		const StringBuffer&,
		DWORD);

	BOOL findNext();

protected:
	BOOL initSearch();
};

#endif
