//	$Id: seq_op.h,v 1.6 2002/04/17 16:23:31 sugiura Exp $
/*
 *	seq_op.h
 *	̃t@CEtH_ɑ΂ďԂɏs߂̏NX
 */

#ifndef DENGAKUSERIES_CLASSES_SEQ_OP
#define DENGAKUSERIES_CLASSES_SEQ_OP

#include "strbuf.h"
#include "linklist.h"
#include "auto_ptr.h"
#include "enumerator.h"

class CmdLineParser;
class DirList;
class PathName;

// SeqOpResult ̗vf̐擪yуt@CƂ̃Zp[^
#define SEQ_OP_RESULT_SUCCESS  (TCHAR)'0'
#define SEQ_OP_RESULT_FAILURE  (TCHAR)'1'
#define SEQ_OP_RESULT_CANCEL   (TCHAR)'2'
#define SEQ_OP_RESULT_SEPCHAR  (TCHAR)'|'

// FLAG_RETURNNUM tOw肵́AX̌ʂێ邽߂̃Xg
class SeqOpResult : public LinkList<StringBuffer>,
					public Enumerator<StringBuffer> {
public:
	SeqOpResult() : m_nSuccess(0), m_head(-1) {}

	// vfĂ邩ǂ -> Enumerator
	BOOL isValid() const { return this->itemNum() > 0; }

	// vfAIɎ擾邽߂̃\bh -> Enumerator
	BOOL findNext()
	{
		return ++m_head < this->itemNum();
	}
	StringBuffer getValue() const
	{
		if (!this->isValid()) return nullStr;
		return *this->getItemByIndex(m_head);
	}

	int m_nSuccess; // ̌JEgJE^

private:
	int m_head; //  getValue() ŕԂvf̃CfbNX
};

// inline Add****() ̎
void AddEnumResult(SeqOpResult*, const StringBuffer&, const StringBuffer&, TCHAR);

// ʂǉ
inline void
AddSuccess(
	SeqOpResult* psor,
	const StringBuffer& path,
	const StringBuffer& path2 = nullStr)
{
	if (psor) psor->m_nSuccess++;
	AddEnumResult(psor, path, path2, SEQ_OP_RESULT_SUCCESS);
}

// sʂǉ
inline void
AddFailure(
	SeqOpResult* psor,
	const StringBuffer& path,
	const StringBuffer& path2 = nullStr)
{
	AddEnumResult(psor, path, path2, SEQ_OP_RESULT_FAILURE);
}

// LZꂽʂǉ
inline void
AddCancel(
	SeqOpResult* psor,
	const StringBuffer& path,
	const StringBuffer& path2 = nullStr)
{
	AddEnumResult(psor, path, path2, SEQ_OP_RESULT_CANCEL);
}


// ̃t@CEtH_ɑ΂ĘAIɏs߂̏NX
class SequentialOp {
public:
	SequentialOp(int, CmdLineParser&, DirList&, SeqOpResult* psor);
	virtual ~SequentialOp();

	// s
	// ̏̂ꂩs FALSE, łȂ TRUE Ԃ
	int doOp();

protected:
	int m_srcIndex; // m_params ̍ŏ̃\[Xt@C̈ʒu
	CmdLineParser& m_params; // ̃Xg
	DirList& m_DirList; // JgtH_̃Xg
	SeqOpResult* m_pEnumResult; // X̌ʂۑ郊Xg
								// (FLAG_RETURNNUM tOw莞̂ݑ݂)

	// ChJ[h̓WJʂ`FbN郁\bh
	// FALSE ԂƂ̃t@CEtH_͏ȂAdoOp() ̖߂lɂ
	// eȂ
	virtual BOOL precheck_wc(WIN32_FIND_DATA&);

	// ChJ[hłȂ̐`FbN郁\bh
	// FALSE ԂƂ̃t@CEtH_͏AdoOp() ̖߂l͕K
	// FALSE ɂȂ
	virtual BOOL precheck_normal(PathName&);

	// ۂ̏s(z)\bh
	// ߂l RO_SUCCESS ARO_FAILED, RO_STOP ̃rbgâꂩ
	// Q NULL łȂꍇAʂ SeqOpResult ɒǉKv
	virtual DWORD do_op(PathName&, SeqOpResult*) = 0;

private:
	// Rs[֎~
	SequentialOp(const SequentialOp&);
	SequentialOp& operator=(const SequentialOp&);
};

// ̃\[XƗB̃fXeBl[VԂɎs
// ߂̘gg݂񋟂֐ƁȀۂɍs֐̌^`
typedef BOOL (*PFN_FILETOFILE)(const PathName&, const PathName&, DWORD, SeqOpResult*);
int FileToFileOperation(PFN_FILETOFILE, DWORD, DirList&, CmdLineParser&, SeqOpResult*&);

#endif
