//	$Id: strbuf.h,v 1.5 2003/07/06 16:27:46 sugiura Exp $
/*
 *	strbuf.h
 *	NX
 */

#ifndef	DENGAKUSERIES_CLASSES_STRBUF
#define	DENGAKUSERIES_CLASSES_STRBUF

#include "array.h"
#include "refcount.h"

#define	BUF_LEN	2

//	NX
class StringBuffer {
public:
	StringBuffer(int len = BUF_LEN);
	StringBuffer(LPCSTR str, int len = -1, int exlen = BUF_LEN);
	StringBuffer(const StringBuffer& that)
		: m_sbuf(that.m_sbuf)
	{
		// nothing to do.
	}
	virtual	~StringBuffer();

	//	required in pathname.h
	operator LPCSTR() const { return m_sbuf->m_buf; }
	//	operator	LPSTR();
	LPSTR getBufPtr();

	StringBuffer& operator=(const StringBuffer& rhs)
	{
		if (this != &rhs) m_sbuf = rhs.m_sbuf;
		return *this;
	}
	StringBuffer& operator=(LPCSTR rhs)
	{
		this->StringBuffer::reset(rhs);
		return *this;
	}
	StringBuffer& operator+=(const StringBuffer& rhs)
	{
		this->StringBuffer::append(rhs); // avoid virtual function call
		return *this;
	}

	void setlength(int);	//	؂߂

	int size() const	//	obt@TCYԂ
	{
		if (!m_sbuf->isShareable()) m_sbuf->recalc();
		return m_sbuf->m_buf.size() - 1; // NULL ̈܂߂Ȃ
	}

	void resize(int newsize)	//	obt@̃TCY𑝂₷(炳Ȃ)
	{
		if (!m_sbuf->isShareable()) m_sbuf->recalc();
		this->dup();
		m_sbuf->resize(newsize);
	}

	virtual	void reset(LPCSTR str = NULL, int head = 0, int len = -1);

	void reset(LPCWSTR str, int head = 0, int len = -1);

	int toUnicode(LPWSTR) const;

	//	wꏊ̕̕ύX
	void setcharAt(int at = -1, TCHAR ch = '\0');

	//	()̒ǉ
	StringBuffer& append(LPCSTR str, int head = 0, int len = -1);
	StringBuffer& append(const StringBuffer& str, int head = 0, int len = -1)
	{ return this->append((LPCSTR)str,head,len); }
	StringBuffer& append(TCHAR);
	StringBuffer& append(int);
	StringBuffer& append(long);
	StringBuffer& append(ULONG);

	//	w蕶̒u
	StringBuffer& replaceStr(LPCSTR ostr, LPCSTR dstr, int num = -1);

	//	(QoCgӎȂ)̔]
	StringBuffer& reverse();

	//	(QoCgӎ)̔]
	StringBuffer& reverse2();

	//	QoCgӎȂ̕ϊ
	StringBuffer& toLower();
	StringBuffer& toUpper();

	//	QoCgӎ镶̕ϊ
	StringBuffer& toLower2();
	StringBuffer& toUpper2();

	// Sp<->pϊ
	StringBuffer& toHankaku();
	StringBuffer& toZenkakuHira();
	StringBuffer& toZenkakuKata();

	//	̔r
	int compareTo(LPCSTR str, BOOL cs = TRUE, int len = -1) const;

	//	raw-level access to the character
	TCHAR operator[](int at) const
	{
		if (!m_sbuf->isShareable()) m_sbuf->recalc();
		return m_sbuf->m_buf[at];
	}

	//	ʂ̏擾\bh
	TCHAR charAt(int at = -1) const;	//	wꏊ̕Ԃ
	int count(LPCSTR) const;	//	w蕶̏oԂ
	int find(TCHAR) const;	//	w蕶̍ŏ̏oʒuԂ
	int rfind(TCHAR) const;	//	w蕶̍Ō̏oʒuԂ

	//	QoCgFȂ擾\bh
	int length() const;			//	̃oCgԂ
	int find(LPCSTR) const;	//	w蕶̍ŏ̏oʒuԂ
	int rfind(LPCSTR) const;	//	w蕶̍Ō̏oʒuԂ
	//	woCgȍ~̎woCg̕𔲂o
	StringBuffer extract(int head, int len = -1) const;

	//	QoCgF擾\bh
	int length2() const;		//	̕Ԃ
	int find2(LPCSTR) const;	//	w蕶̍ŏ̏oʒuԂ
	int rfind2(LPCSTR) const;	//	w蕶̍Ō̏oʒuԂ
	//	w蕶ȍ~̎w蕶̕𔲂o
	StringBuffer extract2(int head, int len = -1) const;

protected:
	//	StringBuffer NX狤Lobt@̎̃NX
	struct StringBuffer_rep : public RCObject {
#ifdef _DEBUG
		int m_id;
#endif
//		int m_bufsize;	//	obt@̃TCY
		int m_len;		//	݊i[̒̕
		Array<TCHAR> m_buf;	//	obt@̎

		StringBuffer_rep(int inisize);
		StringBuffer_rep(LPCSTR str, int len = -1, int exsize = BUF_LEN);
		StringBuffer_rep(const StringBuffer_rep&);
		~StringBuffer_rep();

		void init(LPCSTR,int,int);
		void recalc();
		void resize(int);

		friend class RCPtr<StringBuffer_rep>;
	};

	RCPtr<StringBuffer_rep>	m_sbuf;	//	obt@NXւ̎QƎJEg
									//	X}[g|C^

	void dup();	//	obt@NX̕QƃJEg̒
};

extern const StringBuffer nullStr;

#endif

