// $Id: convdata.cpp,v 1.8 2007/06/02 17:40:59 sugiura Exp $
/*
 *	convdata.cpp
 *	ConvData NX̃RA̎
 */

#include "misc.h"
#include "convdata.h"
#include "ddeserv.h"
#include "cmdline.h"
#include "common.h"

ConvData::ConvData(
	HINSTANCE hInstance,
	DWORD ddeInst,
	HCONV hconv,
	const StringBuffer &strTopicName)
	:	SessionInstance(hInstance,FALSE), // NX
		m_ddeInst(ddeInst), // DDE T[õCX^Xnh
		m_hConv(hconv), // ʐMnh
		m_sbKeepName(nullStr), // KeepAlive ̎ʖ
		m_dsAdvTopicName(ddeInst,strTopicName), // gsbN
		m_dsAdvItemName(ddeInst,"dlgresult"), // AhoCX[vACe
		m_dwLastError(0L), // DdeExecute()  LastError
		m_pComDlgThread(NULL) // R_CAÕXbhւ̃|C^
{
	// AhoCXf[^ւ̃ANZX̓IuWFNg
	m_hAdvEvent	= ::CreateEvent(NULL,TRUE,FALSE,NULL);
}

ConvData::~ConvData()
{
	//	n
	::CloseHandle(m_hAdvEvent);
}

//	AhoCX[v̊Jn
HDDEDATA
ConvData::ddeAdvStart(HSZ hsz1, HSZ hsz2)
{
	DEBUG_OUTPUT(("Enter ddeAdvStart()"));
	if (m_dsAdvTopicName.compareTo(hsz1) != 0 ||
		m_dsAdvItemName.compareTo(hsz2)  != 0) {
		DdeString ds1(m_ddeInst, hsz1), ds2(m_ddeInst, hsz2);
		DEBUG_OUTPUT(("topic = %s, item = %s", (LPCSTR)ds1, (LPCSTR)ds2));
		return HDDE_FALSE;
	}
	::SetEvent(m_hAdvEvent); // setAdvData() ̌ďo
	DEBUG_OUTPUT(("Leave ddeAdvStart()"));
	return HDDE_TRUE;
}

//	AhoCX[v̒~
HDDEDATA
ConvData::ddeAdvStop(HSZ hsz1, HSZ hsz2)
{
	DEBUG_OUTPUT(("Enter ddeAdvStop()"));
	if (m_dsAdvTopicName.compareTo(hsz1) != 0 ||
		m_dsAdvItemName.compareTo(hsz2)  != 0) return HDDE_FALSE;
	::ResetEvent(m_hAdvEvent); // setAdvData() ̌ďo֎~
	DEBUG_OUTPUT(("Leave ddeAdvStop()"));
	return HDDE_TRUE;
}

//	AhoCXf[^̃Zbg
void
ConvData::setNotify(const StringBuffer& data)
{
	//	ddeAdvStart() Ă΂܂őҋ@
	::WaitForSingleObject(m_hAdvEvent,INFINITE);
	try {
		//	AhoCXf[^̃Zbg
		this->SessionInstance::setNotify(data);
		//	f[^ZbgꂽƂNCAgɒʒm
		//	̌Q DdeString::operator HSZ() Ăł
		::PostMessage(DdeServer::gethwndDlg(),WM_USER_NOTIFYPOSTADV,
						0,(LPARAM)this);
	} catch (...) {
		// nothing to do
	}
}

//	AhoCXf[^NCAgɓn
HDDEDATA
ConvData::ddeAdvReq(HSZ hsz1, HSZ hsz2)
{
	try {
		if (m_dsAdvTopicName.compareTo(hsz1) != 0 ||
			m_dsAdvItemName.compareTo(hsz2)  != 0) return HDDE_NULL;
		//	ʒmR[h̎擾
		StringBuffer buf;
		if (!this->getNotify(buf, 0))
		{
			//	̃vZXƒʐM̎ASẴCX^XddeAdvReq()Ă΂̂ŁA
			//	obt@̎ɌĂ΂\B
			return HDDE_NULL;
		}
		//	j[Xbh̒~c^C~OȂ̂ȂcHH
		if (m_pMenuThread.ptr() != NULL) this->stopMenuThread();
		if (m_pComDlgThread.ptr() != NULL) {
			m_pComDlgThread->stop();
			m_pComDlgThread = NULL;
		}
		//	NCAgɓn DDE f[^쐬
		//	SendingDdeData ͔j DdeFreeDataHandle() Ă΂Ȃ
		//	(烍[JIuWFNgł悢)
		DEBUG_OUTPUT(("Enter Create DDE Data"));
		HDDEDATA hData = SendingDdeData(m_ddeInst,
							m_dsAdvItemName.getHandle(),
							buf).getHandle();
		DEBUG_OUTPUT(("Leave Create DDE Data : hData = %08x", hData));

		return hData;
	} catch (...) {
		return HDDE_NULL;
	}
}

//	DDE Execute R}h̎s
HDDEDATA
ConvData::ddeExecute(PFNDDECMD_EXECUTE pfnCmd, CmdLineParser& argv)
{
	try {
		m_dwLastError = 0L;
		::SetLastError(m_dwLastError);
		HDDEDATA ret = (this->*pfnCmd)(argv) ? HDDE_FACK : HDDE_FNOTPROCESSED;
		m_dwLastError = ::GetLastError();

		return ret;
	} catch (...) {
		return HDDE_FNOTPROCESSED;
	}
}

//	DDE Request R}h̎s
HDDEDATA
ConvData::ddeRequest(
	PFNDDECMD_REQUEST pfnCmd,
	CmdLineParser& argv,
	const DdeString& dsItem)
{
	try {
		//	SendingDdeData ͔j DdeFreeDataHandle() Ă΂Ȃ
		//	(烍[JIuWFNgł悢)
		return SendingDdeData(m_ddeInst,
							dsItem.getHandle(),
							(this->*pfnCmd)(argv)).getHandle();
	} catch (...) {
		return HDDE_FNOTPROCESSED;
	}
}

//	DDE Poke R}h̎s
HDDEDATA
ConvData::ddePoke(PFNDDECMD_POKE pfnCmd, CmdLineParser& argv)
{
	try {
		return (this->*pfnCmd)(argv) ? HDDE_FACK : HDDE_FNOTPROCESSED;
	} catch (...) {
		return HDDE_FNOTPROCESSED;
	}
}

