// $Id: ddeserv.cpp,v 1.9 2011/01/07 16:08:38 sugiura Exp $
/*
 *	ddeserv.cpp
 *	DdeServer NX̎
 */

#include "common.h"
#include "ddeserv.h"
#include "ddesinfo.h"
#include "ddeobjs.h"
#include "cmdline.h"
#include "pdparser.h"

//	NXȍ
BOOL DdeServer::m_bActive;
BOOL DdeServer::m_bStrictEmulation;
HINSTANCE DdeServer::m_hInstance;
HWND DdeServer::m_hwndDlg;
DWORD DdeServer::m_ddeInst;
Auto_Ptr<File> DdeServer::m_pfLogFile(NULL);
Auto_Ptr<StringBuffer> DdeServer::m_psbLogFileName(NULL);
Auto_Ptr<DdeString> DdeServer::m_pdsServiceName(NULL);
LinkList<ConvData> DdeServer::m_ConvDataList;
const StringBuffer
DdeServer::m_sbTopicNames(GetServerString(SVR_STR_TOPICNAMES));

//	Ddeml Cugp DDE ʐMR[obN֐
HDDEDATA CALLBACK
ddeCallBack(UINT uType, UINT uFmt, HCONV hconv,
			HSZ hsz1, HSZ hsz2, HDDEDATA hdata,
			HDDEDATA dwData1, HDDEDATA dwData2)
{
	switch (uType) {
	case XTYP_REGISTER: // DDE T[o̊Jn
		return DdeServer::regist(hconv,hsz1,hsz2,hdata);

	case XTYP_UNREGISTER: // DDE T[ȍI
		return DdeServer::unregist(hconv,hsz1,hsz2,hdata);

	case XTYP_CONNECT: // DDE NCAg̐ڑv
		return DdeServer::connect(hconv,hsz1,hsz2,hdata);

	case XTYP_CONNECT_CONFIRM: // DDE ʐM̊m
		//	ʐMf[^Xgɓo^
		return DdeServer::connectconfirm(hconv,hsz1,hsz2,hdata);

	case XTYP_ERROR: // DDE ʐMG[
		return DdeServer::error(hconv,hsz1,hsz2,hdata);

	case XTYP_DISCONNECT: //  DDE ʐM̏I
		return DdeServer::disconnect(hconv,hsz1,hsz2,hdata);

	case XTYP_EXECUTE: // DDE Execute R}h̎s
		return DdeServer::execute(hconv,hsz1,hsz2,hdata);

	case XTYP_REQUEST: // DDE Request R}h̎s
		return DdeServer::request(hconv,hsz1,hsz2,hdata);

	case XTYP_POKE: // DDE Poke R}h̎s
		return DdeServer::poke(hconv,hsz1,hsz2,hdata);

	case XTYP_ADVSTART: // Advice Loop ̊Jn
		return DdeServer::advstart(hconv,hsz1,hsz2,hdata);

	case XTYP_ADVSTOP: // Advice Loop ̏I
		return DdeServer::advstop(hconv,hsz1,hsz2,hdata);

	case XTYP_ADVREQ: // Advice Data ̎擾v
		return DdeServer::advreq(hconv,hsz1,hsz2,hdata);

	default:
		break;
	}
	return HDDE_NULL;
}

//	Ddeml Cugp DDE ʐMR[obN֐(O)
HDDEDATA CALLBACK
ddeCallBack_with_Log(
	UINT uType,
	UINT uFmt,
	HCONV hconv,
	HSZ hsz1,
	HSZ hsz2,
	HDDEDATA hdata,
	HDDEDATA dwData1,
	HDDEDATA dwData2)
{
	switch (uType) {
	case XTYP_REGISTER: // DDE T[o̊Jn
		return DdeServer::lregist(hconv,hsz1,hsz2,hdata);

	case XTYP_UNREGISTER: // DDE T[ȍI
		return DdeServer::lunregist(hconv,hsz1,hsz2,hdata);

	case XTYP_CONNECT: // DDE NCAg̐ڑv
		return DdeServer::lconnect(hconv,hsz1,hsz2,hdata);

	case XTYP_CONNECT_CONFIRM: // DDE ʐM̊m
		//	ʐMf[^Xgɓo^
		return DdeServer::lconnectconfirm(hconv,hsz1,hsz2,hdata);

	case XTYP_ERROR: // DDE ʐMG[
		return DdeServer::lerror(hconv,hsz1,hsz2,hdata);

	case XTYP_DISCONNECT: //  DDE ʐM̏I
		return DdeServer::ldisconnect(hconv,hsz1,hsz2,hdata);

	case XTYP_EXECUTE: // DDE Execute R}h̎s
		return DdeServer::lexecute(hconv,hsz1,hsz2,hdata);

	case XTYP_REQUEST: // DDE Request R}h̎s
		return DdeServer::lrequest(hconv,hsz1,hsz2,hdata);

	case XTYP_POKE: // DDE Poke R}h̎s
		return DdeServer::lpoke(hconv,hsz1,hsz2,hdata);

	case XTYP_ADVSTART: // Advice Loop ̊Jn
		return DdeServer::ladvstart(hconv,hsz1,hsz2,hdata);

	case XTYP_ADVSTOP: // Advice Loop ̏I
		return DdeServer::ladvstop(hconv,hsz1,hsz2,hdata);

	case XTYP_ADVREQ: // Advice Data ̎擾v
		return DdeServer::ladvreq(hconv,hsz1,hsz2,hdata);

	default:
		break;
	}
	return HDDE_NULL;
}

//	DDE T[ȍ
BOOL
DdeServer::init(DDEServerInfo& dsi)
{
	if (m_ddeInst != 0) return m_bActive;

	//	̑̃o̐ݒ
	m_hInstance = dsi.m_hInst;
	m_hwndDlg = dsi.m_hwndMain;
	m_bStrictEmulation = dsi.m_bStrictEmulation;

	//	Ddeml Cu ddeCallBack ֐o^
	if (startLog(dsi.m_psbServerLogFileName)) {
		//	O
		if (::DdeInitialize(&m_ddeInst,(PFNCALLBACK)ddeCallBack_with_Log,
							APPCLASS_STANDARD,0) != DMLERR_NO_ERROR) {
			stopLog();
			return FALSE;
		}
	} else {
		//	OȂ
		if (::DdeInitialize(&m_ddeInst,(PFNCALLBACK)ddeCallBack,
							APPCLASS_STANDARD,0) != DMLERR_NO_ERROR) {
			return FALSE;
		}
	}

	try {
		m_pdsServiceName = new DdeString(m_ddeInst,dsi.m_sbServiceName);
	} catch (...) {
		return FALSE;
	}

	//	Ddeml CuɊ{T[rXo^(DDE T[o̊Jn)
	m_bActive = (BOOL)::DdeNameService(m_ddeInst,
										m_pdsServiceName->getHandle(),
										0L,DNS_REGISTER);

	return m_bActive;
}

//	DDE T[ȍI
BOOL
DdeServer::uninit()
{
	if (m_ddeInst == 0) return TRUE;

	if (m_bActive) {
		try {
			//	ANeBuȒʐMSĔj
			if (m_ConvDataList.itemNum() > 0)
				DdeServer::deleteConvData(NULL);
		} catch (...) {
			// nothing to do
		}

		//	Ddeml Cu{T[rX̓o^폜
		::DdeNameService(m_ddeInst,
						m_pdsServiceName->getHandle(),
						0L,DNS_UNREGISTER);
		m_bActive = FALSE;
	}

	m_pdsServiceName = NULL;

	//	Ddeml CuR[obN֐̓o^폜
	BOOL bRet = ::DdeUninitialize(m_ddeInst);
	m_ddeInst = 0;

	//	O̒~
	stopLog();

	return bRet;
}

//	gsbNǂ
BOOL
DdeServer::isSupportedTopic(const HSZ hszTopicName)
{
	return m_sbTopicNames.find(DdeString(m_ddeInst,hszTopicName)) >= 0;
}

ConvData*
DdeServer::isStoredCD(const HSZ topicname)
{
	try {
		DdeString dsTopicName(m_ddeInst,topicname);
		const StringBuffer& sbTn = (const StringBuffer&)dsTopicName;
		m_ConvDataList.initSequentialGet();
		ConvData* cd;
		while ((cd = m_ConvDataList.getNextItem()) != NULL) {
			if (sbTn.compareTo(cd->getKeepName()) == 0) return cd;
		}
	} catch (...) {
		// nothing to do
	}
	return NULL;
}

//	ʐMNX̐Ao^
int
DdeServer::addConvData(const HCONV hconv, const HSZ hszTn)
{
	ConvData* pCd = isStoredCD(hszTn);
	int	ret = -1;
	if (pCd) {
//		if (pCd->gethConv()) {}	//	Share? or not share?
		pCd->sethConv(hconv);
		pCd->setAdvTopicName(hszTn);
		ret = m_ConvDataList.itemNum();
	} else {
		try {
			pCd = new ConvData(m_hInstance,
								m_ddeInst,
								hconv,
								DdeString(m_ddeInst,hszTn));
		} catch (...) {
			return -1;
		}
		ret = m_ConvDataList.addItem(pCd);
	}
	//	getConvData() ̂߁AʐMf[^Ƀ|C^o^
	if (!::DdeSetUserHandle(hconv,QID_SYNC,reinterpret_cast<DWORD>(pCd))) {
		DEBUG_OUTPUT(("DdeSetUserHandle() error = %08x", ::DdeGetLastError(m_ddeInst)));
	}
	return ret;
}

static void
DelCD(ConvData* pCd, LinkList<ConvData>& cdlist)
{
	pCd->setKeepName(nullStr);
	HCONV hconv = pCd->gethConv();
	if (hconv != NULL) {
		if (DdeServer::isLogging())
			DdeServer::ldisconnect(hconv,NULL,NULL,HDDE_NULL);
		else
			DdeServer::disconnect(hconv,NULL,NULL,HDDE_NULL);
		if (!::DdeDisconnect(hconv)) {
			DEBUG_OUTPUT(("DdeDisconnect() error = %08x", ::DdeGetLastError(DdeServer::getddeInst())));
		}
	} else {
		cdlist.delItemByPtr(pCd);
	}
}

//	T[o̒ʐM̏I
//	disconnect() ĂԂ͕̂KvȂ烍O邽
void
DdeServer::deleteConvData(ConvData* pCd)
{
	if (m_ConvDataList.itemNum() <= 0) return;
	try {
		if (pCd != NULL) {
			//	̒ʐMI
			DelCD(pCd,m_ConvDataList);
		} else {
			//	SʐMI
			//	onDisconnect() ͓ m_pConvDataList->delItemByIndex(0) 
			//	Ăł̂ initSequentialGet() & getNextItem() ̃yA
			//	g킸ɈKvB
			while (m_ConvDataList.itemNum() > 0) {
				DelCD(m_ConvDataList.getItemByIndex(0),m_ConvDataList);
			}
		}
	} catch (...) {
		// nothing to do
	}
}

//	HCONV -> ConvData*
ConvData*
DdeServer::getConvData(const HCONV hconv)
{
	if (hconv == NULL) return NULL;
	//	[U[f[^Ƀ|C^o^Ă (see addConvData())
	CONVINFO ci;
	ci.cb = sizeof(CONVINFO);
	ci.hUser = 0L;
	if (!::DdeQueryConvInfo(hconv,QID_SYNC,&ci)) {
		DEBUG_OUTPUT(("DdeQueryConvInfo() error = %08x", ::DdeGetLastError(m_ddeInst)));
	}
	return reinterpret_cast<ConvData*>(ci.hUser);
}

//	T[o{̂̃vZX DdeAdvReq() ĂԂ߂̃\bh
void
DdeServer::notifyPostAdvise(ConvData* pCd)
{
	//	Ԃɂ̂ōŒ̃`FbNȂ
	if (pCd != NULL) {
		DEBUG_OUTPUT(("Enter notifyPostAdvise()"));
		if (!::DdePostAdvise(m_ddeInst,
							 pCd->getAdvTopicName(),
							 pCd->getAdvItemName())) {
			DEBUG_OUTPUT(("DdePostAdvise() error = %08x", ::DdeGetLastError(m_ddeInst)));
		}
		DEBUG_OUTPUT(("Leave notifyPostAdvise()"));
	}
}

//	O̊Jn
BOOL
DdeServer::startLog(const StringBuffer *psbLogFileName)
{
	if (psbLogFileName == NULL) return FALSE;
	try {
		m_psbLogFileName = new StringBuffer(*psbLogFileName);
	} catch (...) {
		return FALSE;
	}
	m_pfLogFile = new File(*m_psbLogFileName,
							GENERIC_WRITE,
							OPEN_ALWAYS,
							FILE_FLAG_SEQUENTIAL_SCAN);
	if (!m_pfLogFile->isValid()) return FALSE;
	m_pfLogFile->setFilePointer(0, FILE_END);
	return TRUE;
}

//	O̒~
void
DdeServer::stopLog()
{
	if (isLogging()) {
		m_pfLogFile->flushFileBuffers();
		m_pfLogFile = NULL;
		m_psbLogFileName = NULL;
	}
}

BOOL
DdeServer::isLogging()
{
	return m_pfLogFile.ptr() != NULL && m_pfLogFile->isValid();
}

//	Ot@Cւ̏
void
DdeServer::writeLog(LPCSTR logdata)
{
	try {
		StringBuffer buf(40+lstrlen(logdata));
		buf.append((TCHAR)'[').append((ULONG)::GetTickCount()).append("] ")
			.append(logdata).append((TCHAR)'\n');
		if (m_pfLogFile->writeFile((UCHAR*)(LPCSTR)buf,buf.length())
			!= (DWORD)buf.length()) {
			DdeServer::stopLog();
		}
	} catch (...) {
		// nothing to do
	}
	//	ꂪƂȂ葬xቺ(O(^^;)
//	m_pfLogFile->flushFileBuffers();
}

//	Ot@Cւ̏(̒ʐMɂ)
void
DdeServer::writeLog(const HCONV hconv, LPCSTR logdata)
{
	try {
		StringBuffer buf("ConvID: ",-1,40+lstrlen(logdata));
		writeLog(buf.append((ULONG)hconv).append(" : ").append(logdata));
	} catch (...) {
	}
}

//	R}hOɏ
void
DdeServer::writeArgvToLog(
	const HCONV hconv,
	CmdLineParser& ha,
	StringBuffer& header)
{
	try {
		ha.initSequentialGet();
		if (header.length()) {
			writeLog(hconv,header.append(ha.getNextArgv()));
		}
		header.reset(" Argv: ");
		LPCSTR	pav;
		while ((pav = ha.getNextArgv()) != NULL) {
			writeLog(hconv,header.append(pav));
			header.setlength(7);
		}
	} catch (...) {
	}
}

//	DdemlCallBack() ̃bZ[Wnh(O)
HDDEDATA
DdeServer::regist(const HCONV, const HSZ, const HSZ, const HDDEDATA)
{
	return HDDE_NULL; // Ddeml ignores it.
}

HDDEDATA
DdeServer::unregist(const HCONV, const HSZ, const HSZ, const HDDEDATA)
{
	return HDDE_NULL; // Ddeml ignores it.
}

//	ʐMv
//	hsz1 : gsbN
//	hsz2 : {T[rX
HDDEDATA
DdeServer::connect(const HCONV, const HSZ hsz1, const HSZ hsz2, const HDDEDATA)
{
	if (m_pdsServiceName.ptr() == NULL ||
		m_pdsServiceName->compareTo(hsz2) != 0)
		return HDDE_FALSE;
	else if (isSupportedTopic(hsz1)) return HDDE_TRUE;
	return isStoredCD(hsz1) ? HDDE_TRUE : HDDE_FALSE;
}

//	ʐM̊m
//	hconv : ʐMnh
//	hsz1  : gsbN
HDDEDATA
DdeServer::connectconfirm(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ, // not used
	const HDDEDATA) // not used
{
	//	Ddeml ignores it.
	return (HDDEDATA)(addConvData(hconv,hsz1) > 0);
}

//	G[
HDDEDATA
DdeServer::error(const HCONV, const HSZ, const HSZ, const HDDEDATA)
{
	::PostMessage(m_hwndDlg,WM_USER_DDE_STOP,0,0);
	return HDDE_NULL;	//	Ddeml ignores it.
}

//	ʐM̔j
HDDEDATA
DdeServer::disconnect(const HCONV hconv, const HSZ, const HSZ, const HDDEDATA)
{
	try {
		//	Xgo^
		ConvData* cd = getConvData(hconv);
		if (cd != NULL) {
			if (!cd->isKeepAlive())
				m_ConvDataList.delItemByPtr(cd);
			else
				cd->sethConv(NULL);
		}
	} catch (...) {
	}
	return HDDE_NULL;	//	Ddeml ignores it.
}

//	ddeexecute
HDDEDATA
DdeServer::execute(
	const HCONV hconv,
	const HSZ, // not used
	const HSZ, // not used
	const HDDEDATA hdata)
{
	ConvData* cd = getConvData(hconv);
	if (cd == NULL) return HDDE_FNOTPROCESSED;

	try {
		ReceivedDdeData rdd(hdata);
		DEBUG_OUTPUT(("DDE Execute: %s", (LPCSTR)rdd));
		RealCmdLineParser argv((const StringBuffer&)rdd);
		if (argv.itemNum() <= 0) return HDDE_FNOTPROCESSED;
		PFNDDECMD_EXECUTE pfnCmd = getExecCmd(argv.getArgvStr(0));
		if (pfnCmd == 0) return HDDE_FNOTPROCESSED;
		argv.delArgv(0); // cmd name
		return cd->ddeExecute(pfnCmd,argv);
	} catch (...) {
		return HDDE_FNOTPROCESSED;
	}
}

HDDEDATA
DdeServer::request(
	const HCONV hconv,
	const HSZ, // not used
	const HSZ hsz2,
	const HDDEDATA) // not used
{
	ConvData* cd = getConvData(hconv);
	if (cd == NULL) return HDDE_FNOTPROCESSED;

	try {
		DdeString dsItem(m_ddeInst,hsz2);
		DEBUG_OUTPUT(("DDE Request: %s", (LPCSTR)dsItem));
		RealCmdLineParser argv((const StringBuffer&)dsItem);
		if (argv.itemNum() <= 0) return HDDE_FNOTPROCESSED;
		PFNDDECMD_REQUEST pfnCmd = getReqCmd(argv.getArgvStr(0));
		if (pfnCmd == 0) return HDDE_FNOTPROCESSED;
		argv.delArgv(0); // req name
		return cd->ddeRequest(pfnCmd,argv,dsItem);
	} catch (...) {
		return HDDE_FNOTPROCESSED;
	}
}

HDDEDATA
DdeServer::poke(
	const HCONV hconv,
	const HSZ, // not used
	const HSZ hsz2,
	const HDDEDATA hdata)
{
	ConvData* cd = getConvData(hconv);
	if (cd == NULL) return HDDE_FNOTPROCESSED;

	try {
		DdeString dsCmd(m_ddeInst, hsz2);
		PFNDDECMD_POKE pfnCmd = getPokeCmd(dsCmd);
		if (pfnCmd == 0) return HDDE_FNOTPROCESSED;
		ReceivedDdeData rdd(hdata);
		DEBUG_OUTPUT(("DDE Poke: [%s] %s", (LPCSTR)dsCmd, (LPCSTR)rdd));
		PokeDataParser argv((const StringBuffer&)rdd);
		return cd->ddePoke(pfnCmd,argv);
	} catch (...) {
		return HDDE_FNOTPROCESSED;
	}
}

HDDEDATA
DdeServer::advstart(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA) // not used
{
	ConvData* cd = getConvData(hconv);
	HDDEDATA hData = cd != NULL ? cd->ddeAdvStart(hsz1,hsz2) : HDDE_FALSE;
	DEBUG_OUTPUT(("AdvStart() return = %08x", hData));
	return hData;
}

HDDEDATA
DdeServer::advstop(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA) // not used
{
	ConvData* cd = getConvData(hconv);
	//	Ddeml ignores it.
	HDDEDATA hData = cd != NULL ? cd->ddeAdvStop(hsz1,hsz2) : HDDE_FALSE;
	DEBUG_OUTPUT(("AdvStop() return = %08x", hData));
	return hData;
}

HDDEDATA
DdeServer::advreq(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA) // not used
{
	ConvData* cd = getConvData(hconv);
	return cd != NULL ? cd->ddeAdvReq(hsz1,hsz2) : HDDE_NULL;
}

//	DdemlCallBack() ̃bZ[Wnh(OL)
HDDEDATA
DdeServer::lregist(
	const HCONV,
	const HSZ,
	const HSZ,
	const HDDEDATA)
{
	try {
		StringBuffer buf("Start Server : ",-1,32);
		writeLog(buf.append((LPCSTR)*m_pdsServiceName));
	} catch (...) {
	}
	return HDDE_NULL;	//	Ddeml ignores it.
}

HDDEDATA
DdeServer::lunregist(
	const HCONV,
	const HSZ,
	const HSZ,
	const HDDEDATA)
{
	try {
		writeLog("Stop Server");
	} catch (...) {
	}
	return HDDE_NULL;	//	Ddeml ignores it.
}

HDDEDATA
DdeServer::lconnect(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA hdata)
{
	return connect(hconv,hsz1,hsz2,hdata);
}

HDDEDATA
DdeServer::lconnectconfirm(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA hdata)
{
	try {
		HDDEDATA hret = connectconfirm(hconv,hsz1,hsz2,hdata);
		StringBuffer msg("Connect ",-1,32);
		msg.append(hret == HDDE_TRUE ? "Success" : "Failed");
		msg.append(": ").append((LPCSTR)DdeString(m_ddeInst,hsz1));
		writeLog(hconv,msg);
		return hret;	//	Ddeml ignores it.
	} catch (...) {
		return HDDE_FALSE;
	}
}

HDDEDATA
DdeServer::lerror(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA hdata)
{
	try {
		writeLog("Unrecoverable error(s)!! Stop Server");
		return error(hconv,hsz1,hsz2,hdata);
	} catch (...) {
		return HDDE_FALSE;
	}
}

HDDEDATA
DdeServer::ldisconnect(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA hdata)
{
	try {
		writeLog(hconv,"Disconnect");
		return disconnect(hconv,hsz1,hsz2,hdata);
	} catch (...) {
		return HDDE_FALSE;
	}
}

HDDEDATA
DdeServer::lexecute(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA hdata)
{
	ConvData* cd = getConvData(hconv);
	if (cd == NULL) return HDDE_FNOTPROCESSED;

	try {
		ReceivedDdeData rdd(hdata);
		RealCmdLineParser argv((const StringBuffer&)rdd);
		if (argv.itemNum() <= 0) return HDDE_FNOTPROCESSED;
		StringBuffer buf("Execute: ");
		writeArgvToLog(hconv,argv,buf);
		PFNDDECMD_EXECUTE pfnCmd = getExecCmd(argv.getArgvStr(0));
		if (pfnCmd == 0) return HDDE_FNOTPROCESSED;
		argv.delArgv(0); // cmd name
		HDDEDATA hret = cd->ddeExecute(pfnCmd,argv);
		buf = hret == HDDE_FACK ? " Return: Success" : " Return: Failed";
		writeLog(hconv,buf);
		return hret;
	} catch (...) {
		return HDDE_FNOTPROCESSED;
	}
}

HDDEDATA
DdeServer::lrequest(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA hdata)
{
	ConvData* cd = getConvData(hconv);
	if (cd == NULL) return HDDE_FNOTPROCESSED;

	try {
		DdeString dsItem(m_ddeInst,hsz2);
		RealCmdLineParser argv((const StringBuffer&)dsItem);
		if (argv.itemNum() <= 0) return HDDE_FNOTPROCESSED;
		StringBuffer buf("Request: ");
		writeArgvToLog(hconv,argv,buf);
		PFNDDECMD_REQUEST pfnCmd = getReqCmd(argv.getArgvStr(0));
		if (pfnCmd == 0) return HDDE_FNOTPROCESSED;
		argv.delArgv(0); // req name
		HDDEDATA hret = cd->ddeRequest(pfnCmd,argv,dsItem);
		buf = " Return: ";
		if (hret != HDDE_FNOTPROCESSED) {
			buf.append((const StringBuffer&)TemporalDdeData(hret));
		} else {
			buf.append("Failed");
		}
		writeLog(hconv,buf);
		return hret;
	} catch (...) {
		return HDDE_FNOTPROCESSED;
	}
}

HDDEDATA
DdeServer::lpoke(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA hdata)
{
	ConvData* cd = getConvData(hconv);
	if (cd == NULL) return HDDE_FNOTPROCESSED;

	try {
		DdeString dsItem(m_ddeInst,hsz2);
		PFNDDECMD_POKE pfnCmd = getPokeCmd(dsItem);
		if (pfnCmd == 0) return HDDE_FNOTPROCESSED;
		ReceivedDdeData rdd(hdata);
		PokeDataParser argv((const StringBuffer&)rdd);
		StringBuffer buf("Poke : ",-1,dsItem.length());
		writeLog(hconv,buf.append((LPCSTR)dsItem));
		buf = nullStr;
		writeArgvToLog(hconv,argv,buf);
		HDDEDATA hret = cd->ddePoke(pfnCmd,argv);
		buf = hret == HDDE_FACK ? " Return: Success" : " Return: Failed";
		writeLog(hconv,buf);
		return hret;
	} catch (...) {
		return HDDE_FNOTPROCESSED;
	}
}

HDDEDATA
DdeServer::ladvstart(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA hdata)
{
	try {
		HDDEDATA hret = advstart(hconv,hsz1,hsz2,hdata);
		writeLog(hconv,hret == HDDE_TRUE ? "Start Advice Success" :
										   "Start Advice Failed");
		return hret;
	} catch (...) {
		return HDDE_FALSE;
	}
}

HDDEDATA
DdeServer::ladvstop(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA hdata)
{
	try {
		HDDEDATA hret = advstop(hconv,hsz1,hsz2,hdata);
		writeLog(hconv,hret == HDDE_TRUE ? "Stop Advice Success" :
										   "Stop Advice Ignored");
		return hret;
	} catch (...) {
		return HDDE_FALSE;
	}
}

HDDEDATA
DdeServer::ladvreq(
	const HCONV hconv,
	const HSZ hsz1,
	const HSZ hsz2,
	const HDDEDATA hdata)
{
	try {
		HDDEDATA hret = advreq(hconv,hsz1,hsz2,hdata);
		StringBuffer buf("Request Advice Data ",-1,16);
		if (hret != HDDE_NULL) {
			writeLog(hconv,buf.append("Success"));
			buf.reset(" Data: ");
			writeLog(hconv,buf.append((const StringBuffer&)TemporalDdeData(hret)));
		} else {
			writeLog(hconv,buf.append("Failed"));
			buf.reset(" Error code: ");
			writeLog(hconv,buf.append((ULONG)::DdeGetLastError(m_ddeInst)));
		}
		return hret;
	} catch (...) {
		return HDDE_NULL;
	}
}

